#!/bin/bash - 
#===============================================================================
#
#          FILE: run.sh
# 
#         USAGE: ./run.sh 
# 
#   DESCRIPTION: 
# 
#       OPTIONS: ---
#  REQUIREMENTS: ---
#          BUGS: ---
#         NOTES: ---
#        AUTHOR: YOUR NAME (), 
#  ORGANIZATION: 
#       CREATED: 01/17/2020 08:55
#      REVISION:  ---
#===============================================================================

set -o nounset                              # Treat unset variables as an error
VM=pc
disk_setup(){
    modprobe scsi_debug add_host=1
}

disk_cleanup(){
    modprobe -r scsi_debug
}

# $1: dev path
# $2: dev type: b for block, c for char
# $3: vm device xml path
#
run(){
    nsenter -m -t $(pgrep qemu) mkdir $(dirname $1) -p
    nsenter -m -t $(pgrep qemu) mknod $1 $2 8 8
    virsh attach-device $VM $3
    sleep 5
    virsh detach-device $VM $3
}

disk_path=/dev/sdc
usb_path=/dev/bus/usb/001/003
input_path=/dev/input/event1
serial_path=/dev/ttyS2

disk_xml=./disk.xml
usb_xml=./hostdev_usb.xml
input_xml=./input-passthrough.xml
serial_xml=./serial.xml

virsh start $VM && sleep 60

disk_setup
run $disk_path b $disk_xml
run $usb_path b $usb_xml
run $input_path c $input_xml
run $serial_path c $serial_xml
virsh destroy $VM
disk_cleanup
